###########################################################################
#
# This software is governed by a license. See
# LICENSE.txt for the terms of this license.
#
###########################################################################
"""
$Id: registry.py,v 1.1.1.1 2004/12/13 21:06:46 dreamcatcher Exp $
"""

class RegistryException(Exception): pass

class Registry:
    """Registry for data
    """

    def __init__(self, name):
        self.name = name
        self.data = {}

    def get(self, key, default=None):
        return self.data.get(key, default)

    def is_registered(self, name):
        return self.data.has_key(name)

    def register(self, name, instance=None):
        if self.data.has_key(name):
            raise RegistryException, '"%s" already registered' % name

        self.data[name] = instance

    def unregister(self, name):
        del self.data[name]

    def clear(self):
        self.data.clear()

    def allRegisteredObjects(self):
        return self.data.values()

    def allNames(self):
        return self.data.keys()
